Bug 458726 - loopback image not unmounted on i386 buildhost
loopback image not unmounted on i386 buildhost
Status: CLOSED INSUFFICIENT_DATA
Product: Fedora
Classification: Fedora
Component: livecd-tools (Show other bugs)
9
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Jeremy Katz
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-08-11 18:25 EDT by Wart
Modified: 2008-09-30 14:40 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-09-30 14:40:53 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Wart 2008-08-11 18:25:58 EDT
Description of problem:
When creating a i386 live cd on a i386 xen build host, the loopback image used to stage the iso filesystem does not get unmounted, which sometimes results in fsck errors during the image creation.  At best, it leaves behind /dev/loop0 mounted when livecd-creator exits, which must be unmounted manually.

Version-Release number of selected component (if applicable):
livecd-tools-017.1-1.fc9.i386

How reproducible:
Always on a i386 build host, never on x86_64.

Steps to Reproduce:
1. Run 'livecd-creator -c fedora-livedvd-games.ks --cache=../cache -t /pub/tmp'
2. Watch the output
3. run 'mount'
  
Actual results:
errors appear in the output of livecd-creator indicating that the image install root did not get unmounted.  /dev/loop0 is still mounted when the application exits.

Expected results:
/dev/loop0 is unmounted at the appropriate time and is not mounted when the application exits.

Additional info:
/var/log/messages gets filled with fsck errors like:
Aug 11 14:33:18 localhost kernel: EXT3-fs error (device loop0): ext3_free_blocks_sb: bit already cleared for block 1267491

The output of livecd-creator contains:
[...]
/sbin/restorecon reset /root/.tcshrc context system_u:object_r:admin_home_t:s0->system_u:object_r:admin_home_t:s0
umount: /pub/tmp/imgcreate-3gn0Xa/install_root: device is busy
umount: /pub/tmp/imgcreate-3gn0Xa/install_root: device is busy
ioctl: LOOP_CLR_FD: Device or resource busy
umount: /pub/tmp/imgcreate-3gn0Xa/install_root: device is busy
umount: /pub/tmp/imgcreate-3gn0Xa/install_root: device is busy
e2fsck 1.40.8 (13-Mar-2008)
fedora-livedvd-g: recovering journal
Pass 1: Checking inodes, blocks, and sizes
Pass 2: Checking directory structure
Pass 3: Checking directory connectivity
Pass 4: Checking reference counts
Pass 5: Checking group summary information

fedora-livedvd-g: ***** FILE SYSTEM WAS MODIFIED *****
fedora-livedvd-g: 225027/512064 files (1.6% non-contiguous), 1887579/2048000 blocks
[...]

Is this possibly due to some file size limitation on 32-bit buildhosts that is being exceeded by the livedvd image?
Comment 1 Jeremy Katz 2008-08-11 19:08:27 EDT
The ext3 errors do look likely to be the problem.  What do you have backing the disk for your Xen guest?
Comment 2 Wart 2008-08-11 19:31:58 EDT
I'm using a 40GB lvm volume on the xen Dom0 as the disk for the xen guest:

Dom0# lvdisplay /dev/vol0/livemaster-x86
  --- Logical volume ---
  LV Name                /dev/vol0/livemaster-x86
  VG Name                vol0
  LV UUID                okPGQ0-EhB3-0539-XBeS-rGxs-GoaQ-V5ISPG
  LV Write Access        read/write
  LV Status              available
  # open                 1
  LV Size                40.00 GB
  Current LE             1280
  Segments               1
  Allocation             inherit
  Read ahead sectors     auto
  - currently set to     256
  Block device           253:10

...and on the guest:
DomU# # fdisk -l

Disk /dev/xvda: 42.9 GB, 42949672960 bytes
255 heads, 63 sectors/track, 5221 cylinders
Units = cylinders of 16065 * 512 = 8225280 bytes
Disk identifier: 0x000a07d4

    Device Boot      Start         End      Blocks   Id  System
/dev/xvda1   *           1          25      200781   83  Linux
/dev/xvda2              26        5221    41736870   8e  Linux LVM

Disk /dev/dm-0: 40.6 GB, 40600862720 bytes
255 heads, 63 sectors/track, 4936 cylinders
Units = cylinders of 16065 * 512 = 8225280 bytes
Disk identifier: 0x00000000

Disk /dev/dm-0 doesn't contain a valid partition table

Disk /dev/dm-1: 2080 MB, 2080374784 bytes
255 heads, 63 sectors/track, 252 cylinders
Units = cylinders of 16065 * 512 = 8225280 bytes
Disk identifier: 0x30307800

Disk /dev/dm-1 doesn't contain a valid partition table

DomU# df -h
Filesystem            Size  Used Avail Use% Mounted on
/dev/mapper/VolGroup00-LogVol00
                       38G   25G   11G  70% /
/dev/xvda1            190M   22M  160M  12% /boot
tmpfs                 505M     0  505M   0% /dev/shm
/dev/loop2            4.0G  2.0G  2.0G  51% /pub/tmp/imgcreate-uo0DkW/install_root
Comment 3 Wart 2008-08-11 19:39:55 EDT
(In reply to comment #2)
> I'm using a 40GB lvm volume on the xen Dom0 as the disk for the xen guest:
> 
> Dom0# lvdisplay /dev/vol0/livemaster-x86
>   --- Logical volume ---
>   LV Name                /dev/vol0/livemaster-x86
>   VG Name                vol0
>   LV UUID                okPGQ0-EhB3-0539-XBeS-rGxs-GoaQ-V5ISPG
>   LV Write Access        read/write
>   LV Status              available
>   # open                 1
>   LV Size                40.00 GB
>   Current LE             1280
>   Segments               1
>   Allocation             inherit
>   Read ahead sectors     auto
>   - currently set to     256
>   Block device           253:10
[...]

...vol0 based on a single pv on a 700GB partition on a locally attached sata drive:

  --- Physical volume ---
  PV Name               /dev/sda2
  VG Name               vol0
  PV Size               698.54 GB / not usable 4.40 MB
  Allocatable           yes 
  PE Size (KByte)       32768
  Total PE              22353
  Free PE               19158
  Allocated PE          3195
  PV UUID               NEEs4y-Dycd-bbgW-i0b3-DuRJ-1Xsn-VAmNV8


> DomU# df -h
> Filesystem            Size  Used Avail Use% Mounted on
> /dev/mapper/VolGroup00-LogVol00
>                        38G   25G   11G  70% /
> /dev/xvda1            190M   22M  160M  12% /boot
> tmpfs                 505M     0  505M   0% /dev/shm
> /dev/loop2            4.0G  2.0G  2.0G  51%
> /pub/tmp/imgcreate-uo0DkW/install_root

/dev/loop2 is the result of running 'livecd-creator -c fedora-livecd-desktop.ks'.  I get the same umount and fsck errors when building the live desktop image and the games live dvd.
Comment 4 Jeremy Katz 2008-08-27 13:24:11 EDT
Are you seeing any errors on the dom0 side, either in kernel messages or the xen logs?

As this is definitely working for me locally, though not in a Xen guest.  Which makes me lean towards it being some odd Xen interaction
Comment 5 Jeremy Katz 2008-09-30 14:40:53 EDT
Closing due to inactivity.  Please reopen if you have further information which you can add to the report.

Note You need to log in before you can comment on or make changes to this bug.